-- Global variables
PLUGIN = {}	-- Reference to own plugin object
-- LOGIC
PORTAL_ACTIVATION_TIME = 3
PlayersData = {}	-- this would be a hashtable for players not-moving times and admins enable/disable modes
PortalsData = {}
	PortalsData.warps = {}
	PortalsData.enters = {}

function Initialize(Plugin)
	PLUGIN = Plugin
	PLUGIN:SetName("Portal")
	PLUGIN:SetVersion(1)
	
	PluginManager = cRoot:Get():GetPluginManager()
	PluginManager:AddHook(PLUGIN, cPluginManager.HOOK_TICK)
	PluginManager:AddHook(PLUGIN, cPluginManager.HOOK_PLAYER_MOVE)
	PluginManager:AddHook(PLUGIN, cPluginManager.HOOK_BLOCK_PLACE)	-- for admin purpose only - to create portal entrance zones
	PluginManager:AddHook(PLUGIN, cPluginManager.HOOK_BLOCK_DIG)	-- for admin purpose only - to create portal entrance zones
	
	Plugin:AddCommand("/ptoggle",	" - switches volume selection mode",				"portal.create")
	Plugin:AddCommand("/pwarp",		" (name) - creates warp point with given name",		"portal.create")
	Plugin:AddCommand("/penter",	" (name) - creates portal volume out of selection and associates it with given warp",		"portal.create")
	
	Plugin:BindCommand("/ptoggle",	"portal.create",	HandleToggleCommand)
	Plugin:BindCommand("/pwarp",	"portal.create",	HandleMakeWarpCommand)
	Plugin:BindCommand("/penter",	"portal.create",	HandleMakeEnterCommand)
	
	Plugin:AddWebTab("Portals", HandleRequest_Portals)
	
	LOG("Initialized " .. PLUGIN:GetName() .. " v" .. PLUGIN:GetVersion())
	return true
end

function OnDisable()
	LOG(PLUGIN:GetName() .. " v" .. PLUGIN:GetVersion() .. " is shutting down...")
end

function Tick()
	local CheckTeleportation = function(Player)
		local _name = Player:GetName()
		if (PlayersData[_name] ~= nil) then
			local _zone = FindZone(Player)
			if (_zone ~= false) then
				if (os.difftime(os.time(), PlayersData[_name].portal_timer) > PORTAL_ACTIVATION_TIME) then
					-- TELEPOOOOOORT!!!!!!1111
					--if (Player:GetWorld():GetName() ~= _zone.)
				end
			end
		end
	end
	local CheckPlayersInTheWorld = function(World)
		World:ForEachPlayer(CheckTeleportation)
	end
	cRoot:Get():ForEachWorld(CheckPlayersInTheWorld)
end

function OnPlayerMove(Player)
	local _name = Player:GetName()
	if (PlayersData[_name] == nil) then
		PlayersData[_name] = {}	-- create player's page
	end
	if (FindZone(Player) ~= false) then
		LOG("Name is: "..FindZone(Player))
		PlayersData[_name].portal_timer = os.time()
	end
    return false
end

-- LEFTCLICK!
function OnBlockDig(Player, IN_x, IN_y, IN_z, BlockFace, Status, OldBlock, OldMeta)
	local _name = Player:GetName()
	if (PlayersData[_name] == nil) then
		PlayersData[_name] = {}	-- create player's page
	end
	if (PlayersData[_name].create_volume_mode ~= nil) then
		if (PlayersData[_name].create_volume_mode == true) then
			if (Player:GetInventory():GetEquippedItem().m_ItemID == E_ITEM_WOODEN_SWORD) then
				if (PlayersData[_name].point1 == nil) then
					PlayersData[_name].point1 = Vector3i()
				end
				PlayersData[_name].point1.x = IN_x
				PlayersData[_name].point1.y = IN_y
				PlayersData[_name].point1.z = IN_z
				Player:SendMessage("First portal entrance volume point selected")
				return true
			end
		end
	end
	return false
end

-- RIGHTCLICK!
function OnBlockPlace(Player, IN_x, IN_y, IN_z, BlockFace, HeldItem)
	local _name = Player:GetName()
	if (PlayersData[_name] == nil) then
		PlayersData[_name] = {}	-- create player's page
	end
	if (PlayersData[_name].create_volume_mode ~= nil) then
		if (PlayersData[_name].create_volume_mode == true) then
			if (HeldItem.m_ItemID == E_ITEM_WOODEN_SWORD) then
				if (PlayersData[_name].point2 == nil) then
					PlayersData[_name].point2 = Vector3i()
				end
				PlayersData[_name].point2.x = IN_x
				PlayersData[_name].point2.y = IN_y
				PlayersData[_name].point2.z = IN_z
				Player:SendMessage("Second portal entrance volume point selected")
				return true
			end
		end
	end
	return false
end